{{
***********************************
* Martin Hebel                    *
* Southern Illinois University    *
* SelmaWare Solutions             *
* 7/8/07                          *
***********************************


}}

CON 
    _clkmode = xtal1 + pll16x      '80MHz operating frequency.
    _xinfreq = 5_000_000

    XB_Rx = 7
    XB_Tx = 6

    Base_addy = 0
    MaxStrLen = 16
                          

VAR   '' Global Variables and Cog Stack Space
   byte  RSSI, Message[MaxStrLen], ID, Value
OBJ 
  XB   : "XBee_Object"       
  Comm : "FullDuplexSerial"  
  Num  : "Numbers"

Pub Start | check
    XB.start(XB_Rx,XB_Tx,0,9600)           ' XBee Comms - RX,TX, Mode, Baud
    Comm.start(31,30,0,9600)             ' Initialize comms from Prop to PC
    XB.AT_Init                           ' Initialize for fast AT command use - 5 second delay to perform
    num.init                             ' Initialize Numbers object
    XB.AT_Config(string("ATMY 1"))       ' Set for address of 1 
    XB.AT_Config(string("ATAP 1"))       ' change to API mode
    Process
    

Pub Process
 repeat
   GetData                               ' Go wait on data
   if ID < 5                             ' based on ID, display to serial port window
      comm.str(string(13,13,"ID:"))
      comm.dec(ID)
      comm.str(string(13,"Value:"))
      comm.dec(Value)
      comm.str(string(13,"RSSI:"))
      comm.dec(RSSI)
   if ID == 5
      comm.str(string(13,13,"ID:"))
      comm.dec(ID)
      comm.str(string(13,"Message:"))
      comm.str(@Message)
      comm.str(string(13,"RSSI:"))
      comm.dec(RSSI)      
   
Pub GetData | ptr
    ' Based on RxIdent (type of packet), displays information
    ID := -1                                   ' Set ID to -1 for no Rx data just in case
    XB.API_Rx                                 ' Wait for API data
                                              ' Can also use XB.API_RxTime(500) to wait for 500 mSec
                                              ' but with small buffer, easy to miss data

    If XB.rxIdent ==  $81                     ' If ident for XB packet is for received data
          RSSI := XB.RxRSSI                   ' Record RSSI level
          ID := num.FromStr(XB.RxData,num#dec)      ' Get ID from 1st part of string
          Value := num.FromStr(Xb.RxData+4,num#dec) ' get and convert value from rest of string
          byteMove(@Message,Xb.RxData+4,MaxStrLen)  ' also save as a message for ID's of 5 
    

PUB CR
  comm.tx(13)
